<?php

//Note that since we are using classes, the prefix use is not useful anymore. Nonetheless, watchout html id tags
//Also I didn't find a practical way to instance the class and include the page in the process.
//So, I decided to make a static class to make it work
//Updated: after reconverting the class to static and reformating array(&$this,'method') to settingsAPI::method, it SEEMS is working!!!
/*
in the database will be stored something like statcomm_options:
a:6:{s:10:"chk_logged";s:2:"on";s:14:"chk_no_spiders";N;s:19:"cmb_delete_visitors";s:8:"3 months";s:18:"cmb_delete_spiders";
s:6:"1 Week";s:18:"cmb_overview_graph";s:2:"30";s:14:"cmb_capability";s:20:"edit_published_posts";}
So, the correct way to get the data is:
$options= get_option("statcomm_options");
echo "logged:" . (($options["chk_logged"]=='on')?'on':'off') . "<br/>"; //ONE WAY
echo "spiders:" . (($options["chk_no_spiders"]=='on')?'1':'0') . "<br/>"; //ANOTHER WAY, maybe better
echo "cmb_delete_visitors:" . $options["cmb_delete_visitors"] . "<br/>";
echo "cmb_delete_spiders:" . $options["cmb_delete_spiders"] . "<br/>";
echo "cmb_overview_graph:" . $options["cmb_overview_graph"] . "<br/>";
echo "cmb_capability:" . $options["cmb_capability"] . "<br/>";

Note also we don't need to put a prefix on options: we have an array properly prefixed, the inner valuer do not need to be prefixed.

To improve: the combo cannot easily be translated, since I'storing the select value and not the inner one. this has to be corrected
on the combos.

*/

class settingsAPI
{
	// Draw the option page
	static function statcomm_option_page() {
		?>
		<div class="wrap">
			<?php screen_icon(); ?>
			<h2>Options</h2>
			<form action="options.php" method="post">
				<?php settings_fields('statcomm_options'); ?>
				<?php do_settings_sections('statcomm_setting_page'); ?><br/>
			<input class="button-primary" name="Submit" type="submit" value="<?php _e('Save Settings','statcomm'); ?>" />
			</form>
		</div>
		<?php
	}

	//Basic idea: don't mess with options names, they are already defined.
	static function getOptions()
	 {
		return get_option("statcomm_options");
	 }

	static function statcomm_admin_init(){
		//register_setting(group_name,option_name,callback)
		register_setting('statcomm_options',	'statcomm_options','settingsAPI::statcomm_validate_options');

		//add_settings_section(html_id_tag,title,callback,settings page)
		add_settings_section('statcomm_main',__('StatComm Settings','statcomm'),'settingsAPI::statcomm_section_text','statcomm_setting_page');

		//add_settings_field(html_id_tag,text,callback,page,id_section)
//		add_settings_field('statcomm_text_string','Enter text here',	array(&$this,'statcomm_setting_input'),	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_chk_log',__('Also collect data about logged users','statcomm'),	'settingsAPI::statcomm_setting_chk_log',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_chk_no_spiders',__('Do not collect spiders visits','statcomm'),	'settingsAPI::statcomm_setting_chk_no_spiders',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_delete_visitors',__('Automatically delete visits older than'),	'settingsAPI::statcomm_setting_delete_visitors',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_delete_spiders',__('Automatically delete spiders older than'),	'settingsAPI::statcomm_setting_delete_spiders',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_overview_graph',__('Days in Overview graph'),	'settingsAPI::statcomm_overview_graph',	'statcomm_setting_page','statcomm_main');

		add_settings_field('statcomm_capability',__('Min. allowed access'),	'settingsAPI::statcomm_capability',	'statcomm_setting_page','statcomm_main');
	}

	// Draw the section header
	static function statcomm_section_text() {
		//echo '<p>' . __('Current settings for StatComm','statcomm') . '</p>';
	}

	/*
	// Display and fill the form field
	// It's worth mentioning that ID settings in the add_settings_field DOES NOT HAVE TO MATCH ID input field HTML Tag
	// in this callback function. Just remember avoid conflicting names
	function statcomm_setting_input() {
		// get option 'text_string' value from the database
		$options = get_option( 'statcomm_options' );
		$text_string = $options['text_string'];
		// echo the field
		echo "<input id='text_string' name='statcomm_options[text_string]' type='text' value='$text_string' />";
	}
	*/
	static function statcomm_setting_chk_log() {
		// get option 'text_string' value from the database
		$options = get_option( 'statcomm_options' );
		$text_string = $options['chk_logged'];
		$checked='';
		if($options['chk_logged']) { $checked = ' checked="checked" '; }
		echo "<input id='chk_logged' name='statcomm_options[chk_logged]' type='checkbox' $checked />";
	}

	static function statcomm_setting_chk_no_spiders() {
		// get option 'text_string' value from the database
		$options = get_option( 'statcomm_options' );
		$text_string = $options['chk_no_spiders'];
		$checked='';
		if($options['chk_no_spiders']) { $checked = ' checked="checked" '; }
		echo "<input id='chk_no_spiders' name='statcomm_options[chk_no_spiders]' type='checkbox' $checked />";

	}

	static function statcomm_setting_delete_visitors() {
		$options = get_option( 'statcomm_options' );
		$items = array("Never delete!", "1 month", "3 months", "6 months", "1 year");
		echo "<select id='cmb_delete_visitors' name='statcomm_options[cmb_delete_visitors]'>";
		foreach($items as $item) {
			$selected = ($options['cmb_delete_visitors']==$item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select>";
	}

	static function statcomm_setting_delete_spiders() {
		$options = get_option( 'statcomm_options' );
		$items = array("Never delete!", "1 Day", "1 Week", "1 Month", "1 Year");
		echo "<select id='cmb_delete_spiders' name='statcomm_options[cmb_delete_spiders]'>";
		foreach($items as $item) {
			$selected = ($options['cmb_delete_spiders']==$item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select>";
	}

	static function statcomm_overview_graph() {
		$options = get_option( 'statcomm_options' );
		$items = array("7", "10", "20", "30", "50");
		echo "<select id='cmb_overview_graph' name='statcomm_options[cmb_overview_graph]'>";
		foreach($items as $item) {
			$selected = ($options['cmb_overview_graph']==$item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select>";
	}

	//Improved: no more indescifrable minimum capability. Note that plugin is not yet multisite.
	static function statcomm_capability() {
		$options = get_option( 'statcomm_options' );
		$items = array( array ("Super Admin","manage_network")
					,   array ("Administrator", "activate_plugins")
				    ,   array ("Editor", "moderate_comments")
					,   array ("Author", "edit_published_posts")
					,   array ("Contributor", "edit_posts")
					,   array ("Suscriber","read") );

		echo "<select id='cmb_capability' name='statcomm_options[cmb_capability]'>";
		foreach($items as $item) {
			$selected = ($options['cmb_capability']==$item[1]) ? 'selected="selected"' : '';
			echo "<option value='{$item[1]}' $selected>{$item[0]}</option>";
		}
		echo "</select>";
		echo "<div> " . _e("Need help about roles?","statcomm") . "<a target='_blank' href='http://codex.wordpress.org/Roles_and_Capabilities#Summary_of_Roles'>Go to Wordpress Codex Help: Roles & Capabilities</a></div>";
	}

	// Validate user input (we want text only)
	// IMPORTANT: this function gets an array in ($input) and array out $valid. EVERY FIELD has to be copied
	// from on array to another previous validation. If not, data of fields won't be saved.
	static function statcomm_validate_options( $input ) {
		/*
		$valid['text_string'] = preg_replace( '/[^a-zA-Z]/', '', $input['text_string'] );

		if( $valid['text_string'] != $input['text_string'] ) {
		//add_settings_error(title_setting,html_id_tag,error_msg,error/update
			add_settings_error('statcomm_text_string','statcomm_texterror','Incorrect value entered!','error');
		}
		*/
		//$valid= array('chk_logged','chk_no_spiders','cmb_delete_visitors','cmb_delete_spiders',
		//'cmb_overview_graph','cmb_capability');
		$valid['chk_logged']          = isset($input['chk_logged'])?$input['chk_logged']:"";
		$valid['chk_no_spiders']      = isset($input['chk_no_spiders'])?$input['chk_no_spiders']:"";
		$valid['cmb_delete_visitors'] = isset($input['cmb_delete_visitors'])?$input['cmb_delete_visitors']:"";
		$valid['cmb_delete_spiders']  = isset($input['cmb_delete_spiders'])?$input['cmb_delete_spiders']:"";
		$valid['cmb_overview_graph']  = isset($input['cmb_overview_graph'])?$input['cmb_overview_graph']:"";
		$valid['cmb_capability']      = isset($input['cmb_capability'])?$input['cmb_capability']:"";
		//add_settings_error('statcomm_ok','statcomm_ok','Options saved!','update');

		return $valid;
	}
}
?>